ModuleDescriptor.Requires.Modifier (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.lang.module, class: ModuleDescriptor, class: Requires, enum: Modifier
Keywords: java.lang.module.ModuleDescriptor.Requires.Modifier class

# Enum Class ModuleDescriptor.Requires.Modifier

java.lang.Object
java.lang.Enum<ModuleDescriptor.Requires.Modifier>
java.lang.module.ModuleDescriptor.Requires.Modifier

All Implemented Interfaces:
  `Serializable, Comparable<ModuleDescriptor.Requires.Modifier>, Constable`

Enclosing class:
  `ModuleDescriptor.Requires`

public static enum ModuleDescriptor.Requires.Modifier extends Enum<ModuleDescriptor.Requires.Modifier>
A modifier on a module dependence.

Since:
  9
See Also:
  - `ModuleDescriptor.Requires.modifiers()`

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`
  Modifier and Type
  Class
  Description
  `static final class`
  `Enum.EnumDesc<E extends Enum<E>>`
  A nominal descriptor for an `enum` constant.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `MANDATED`
  The dependence was implicitly declared in the source of the module declaration.
  `STATIC`
  The dependence is mandatory in the static phase, during compilation, but is optional in the dynamic phase, during execution.
  `SYNTHETIC`
  The dependence was not explicitly or implicitly declared in the source of the module declaration.
  `TRANSITIVE`
  The dependence causes any module which depends on the current module to have an implicitly declared dependence on the module named by the `Requires`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static ModuleDescriptor.Requires.Modifier`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static ModuleDescriptor.Requires.Modifier[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`
  Modifier and Type
  Method
  Description
  `protected final Object`
  `clone()`
  Throws CloneNotSupportedException.
  `final int`
  `compareTo(ModuleDescriptor.Requires.Modifier o)`
  Compares this enum with the specified object for order.
  `final Optional<Enum.EnumDesc<ModuleDescriptor.Requires.Modifier>>`
  `describeConstable()`
  Returns an enum descriptor `EnumDesc` for this instance, if one can be constructed, or an empty `Optional` if one cannot be.
  `final boolean`
  `equals(Object other)`
  Returns true if the specified object is equal to this enum constant.
  `protected final void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization has been deprecated for removal.
  `final Class<ModuleDescriptor.Requires.Modifier>`
  `getDeclaringClass()`
  Returns the Class object corresponding to this enum constant's enum type.
  `final int`
  `hashCode()`
  Returns a hash code for this enum constant.
  `final String`
  `name()`
  Returns the name of this enum constant, exactly as declared in its enum declaration.
  `final int`
  `ordinal()`
  Returns the ordinal of this enumeration constant (its position in its enum declaration, where the initial constant is assigned an ordinal of zero).
  `String`
  `toString()`
  Returns the name of this enum constant, as contained in the declaration.
  `static <T extends Enum<T>>
  T`
  `valueOf(Class<T> enumClass, String name)`
  Returns the enum constant of the specified enum class with the specified name.

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Enum Constant Details

  - ### TRANSITIVE

    public static final ModuleDescriptor.Requires.Modifier TRANSITIVE
    The dependence causes any module which depends on the current module to have an implicitly declared dependence on the module named by the `Requires`.

  - ### STATIC

    public static final ModuleDescriptor.Requires.Modifier STATIC
    The dependence is mandatory in the static phase, during compilation, but is optional in the dynamic phase, during execution.

  - ### SYNTHETIC

    public static final ModuleDescriptor.Requires.Modifier SYNTHETIC
    The dependence was not explicitly or implicitly declared in the source of the module declaration.

  - ### MANDATED

    public static final ModuleDescriptor.Requires.Modifier MANDATED
    The dependence was implicitly declared in the source of the module declaration.

- ## Method Details

  - ### values

    public static ModuleDescriptor.Requires.Modifier[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static ModuleDescriptor.Requires.Modifier valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null